//
//  KSTransDownloadManager.h
//  kinescopeClient
//
//  Created by ihawk on 7/9/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "Torrent.h"
#import "KSTransmission.h"


@interface KSTransDownloadManager : Torrent 
{
	NSString * url;
	NSString * outputFile;
	NSString *filenameOfDescribedFile;
	id delegate;
	NSString *torrentFilePath;
	BOOL asURL;
	BOOL isError;
	BOOL isPrepared;
	BOOL isStopped;
	
	NSNumber *fileSize;
	NSNumber *downloadRate;
	NSNumber *percentDone;
	NSNumber *uploadRate;
	NSNumber *seedCount;
	NSNumber *peerCount;
	NSNumber *downloadDone;
	NSNumber *isSeeding;   
}

+(id)torrentManagerWithPath:(NSString *)torrentPath outputFile:(NSString *)torrentOutputFile delegate:(id)del;
+(id)torrentManagerWithURL:(NSString *)torrentURL outputFile:(NSString *)torrentOutputFile delegate:(id)del;

-(void) start;
-(void) stop;
-(void) pause;
-(void) resume;
-(BOOL)hasActiveConnections;
-(BOOL)Prepared;
//base Torrent class contains correct information about download process (for example means that torrent from  url alread downloaded and download based on torrent file started)  

@end

@interface KSTransDownloadManager (Private)

-(id)init:(NSString *)torrentLocation asURL:(BOOL)isURL outputFile:(NSString *)torrentOutputFile delegate:(id)del;
-(id)initWithPath:(NSString *)torrentPath outputFile:(NSString *)torrentOutputFile delegate:(id)del;
-(id)initWithURL:(NSString *)torrentURL outputFile:(NSString *)torrentOutputFile delegate:(id)del;

- (void) downloadTorrent;
- (void) downloadData;

@end


@interface NSObject (KSTransDownloadManagerDelegate)

-(void)torrentStatusUpdated:(id)manager;
-(void)torrentDownloadFinished:(id)manager;

@end

